'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = function (context) {
  var profile = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  var config = {
    profile: profile,
    module: {
      rules: (0, _loaders2.default)(context)
    },
    resolve: {
      extensions: ['.js', '.json', '.es6', '.jsx', '.styl', '.css', '.less', '.scss']
    }
  };

  var happypackPlugins = [(0, _lib.happypackPlugin)('js', [{
    loader: require.resolve('babel-loader'),
    options: { cacheDirectory: true }
  }])];

  var plugins = [].concat(happypackPlugins);

  if (profile) {
    plugins.push(new _webpackBundleAnalyzer.BundleAnalyzerPlugin({
      analyzerMode: 'static',
      reportFilename: 'bundle-analyzer-report.html',
      openAnalyzer: false,
      logLevel: 'info'
    }));
  }

  var restConfig = context.isDev ? {
    devtool: '#cheap-source-map',
    watch: true,
    performance: { hints: false },
    plugins: [].concat(_toConsumableArray(plugins), [new _webpack2.default.HotModuleReplacementPlugin()])
  } : {
    // devtool: "#cheap-module-source-map",
    devtool: profile ? '#cheap-module-source-map' : false,
    plugins: [].concat(_toConsumableArray(plugins), [new _webpack2.default.NoEmitOnErrorsPlugin(), new _webpack2.default.DefinePlugin({
      'process.env.NODE_ENV': JSON.stringify('production')
    }), new _webpack2.default.HashedModuleIdsPlugin({
      hashFunction: 'sha256',
      hashDigest: 'hex',
      hashDigestLength: 10
    }), new _webpack2.default.optimize.UglifyJsPlugin({
      comments: false,
      sourceMap: false,
      output: {
        comments: false
      }
    }), new _extractTextWebpackPlugin2.default({ filename: context.output.cssPath })])
  };
  return _extends({}, config, restConfig);
};

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _extractTextWebpackPlugin = require('extract-text-webpack-plugin');

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

var _webpackBundleAnalyzer = require('webpack-bundle-analyzer');

var _loaders = require('./loaders');

var _loaders2 = _interopRequireDefault(_loaders);

var _lib = require('./lib');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }